-------------------------------------------------------------------------------------
-- Script per a provar totes les funcionalitats desenvolupades per a la plataforma --
-- a excepci del mdul estadstic que es testeja a banda                          --
-------------------------------------------------------------------------------------

DECLARE 

RSP VARCHAR2(500 CHAR);
tblLlistatDesPais tblTAULALLISDESPAIS;
tblLlistatAppActives tblTAULALLISAPPACTIVES;
tblLlistatAppAny tblTAULALLISAPPANY;
tblLlistatDescUsuari tblTAULALLISDESCUSU;
tblLlistatTop20Usuari tblTAULALLISTOP20USU;
tblLlistatBinaris tblLLISTATBINARISAPP;
tblDesenvolupadors tblLLISTATDESENVOLUPADORS;
tblDispositius tblLLISTATDISPOSITIUS;
intCodiUsuari NUMBER;
intCodiDispositiu NUMBER;
intCodiAplicacio NUMBER;
intCodiDesenvolupador NUMBER;
intPreu NUMBER(4,2);
strDescripcio VARCHAR2(100 CHAR);
typDadesUsuari typUSUARI;
typDadesAplicacio typAPLICACIO;
tblLlistatSO tblTAULALLISTSOAPP;
intCodiBinari NUMBER;
typDadesBinari typBINARI;
typDadesDesenvolupador typDESENVOLUPADOR;

BEGIN

proAltaAplicacio(NULL,NULL,NULL,NULL,intCodiAplicacio,RSP); -- Alta aplicaci amb codi identificador NULL
proAltaAplicacio('Aplicacio1',NULL,NULL,NULL,intCodiAplicacio,RSP); -- Alta aplicaci amb codi identificador que ja existeix
proAltaAplicacio('Nova Aplicacio',NULL,NULL,22,intCodiAplicacio,RSP); -- Alta aplicaci amb codi de resolucio que no existeix
proAltaAplicacio('Nova Aplicacio',NULL,NULL,4,intCodiAplicacio,RSP); -- Alta aplicaci correcta
dbms_output.put_line('proAltaAplicacio_intCodiAplicacio:' || intCodiAplicacio); 

proBaixaAplicacio(NULL,NULL,RSP); -- Baixa aplicaci amb codi i nom identificador NULL
proBaixaAplicacio(22,NULL,RSP); -- Baixa aplicaci amb codi que no existeix
proBaixaAplicacio(NULL,'App',RSP); -- Baixa aplicaci amb nom identificador que no existeix   
proBaixaAplicacio(7,'111111112',RSP); -- Baixa aplicaci amb codi que existeix pero no el nom identificador, per a comprovar que el codi preval sobre el nom
proBaixaAplicacio(NULL,'Nova Aplicacio',RSP); -- Baixa aplicaci amb nom identificador existent i que l'aplicaci ja estava donada de baixa

proModificaAplicacio(NULL,NULL,NULL,NULL,NULL,RSP); -- Modificaci d'una aplicaci amb codi NULL
proModificaAplicacio(233,NULL,NULL,NULL,NULL,RSP); -- Modificaci d'una aplicaci amb codi no existent  
proModificaAplicacio(7,NULL,NULL,NULL,NULL,RSP); -- Modificaci d'una aplicaci amb tots els camps a modificar NULL  
proModificaAplicacio(7,'V2.00',NULL,NULL,NULL,RSP); -- Modificaci de la versi d'una aplicaci
proModificaAplicacio(7,NULL,'linkNouAlVideoDemo',NULL,NULL,RSP); -- Modificaci del link al video demo d'una aplicaci   
proModificaAplicacio(7,NULL,NULL,455,NULL,RSP);  -- Modificaci de la resoluci d'una aplicaci amb un codi que no existeix
proModificaAplicacio(7,NULL,NULL,1,NULL,RSP); -- Modificaci de la resoluci d'una aplicaci amb un codi correcte
proModificaAplicacio(7,NULL,NULL,NULL,'ss',RSP); -- Modificaci del flag d'aplicaci activa amb un valor incorrecte, diferent de 'S' i 'N'
proModificaAplicacio(7,NULL,NULL,NULL,'S',RSP); -- Modificaci del flag d'aplicaci activa amb un dels dos valors correctes: 'S'
proModificaAplicacio(7,NULL,NULL,NULL,'N',RSP); -- Modificaci del flag d'aplicaci activa amb un dels dos valors correctes: 'N'   

proConsultaAplicacio (NULL,typDadesAplicacio,RSP); -- Consulta de les dades d'una aplicaci amb codi NULL
proConsultaAplicacio (58,typDadesAplicacio,RSP); -- Consulta de les dades d'una aplicaci amb codi inexistent
proConsultaAplicacio (1,typDadesAplicacio,RSP); -- Consulta de les dades d'una aplicaci
dbms_output.put_line('codi:' || typDadesAplicacio.codi || ',' 
                  || 'idAplicacio:' || typDadesAplicacio.idAplicacio || ','
                  || 'dataAlta:' || typDadesAplicacio.dataPujada || ',' 
                  || 'dataBaixa:' || typDadesAplicacio.dataBaixa || ',' 
                  || 'versio:' || typDadesAplicacio.versio || ',' 
                  || 'linkVideo:' || typDadesAplicacio.linkVideo || ',' 
                  || 'resolucioMinima:' || typDadesAplicacio.resolucioMinima || ',' 
                  || 'activa:' || typDadesAplicacio.activa);


proAltaAppPreuPais(NULL,NULL,NULL,RSP); -- Alta del preu d'una aplicaci amb codi d'aplicaci NULL
proAltaAppPreuPais(55,NULL,NULL,RSP); -- Alta del preu d'una aplicaci amb codi d'aplicaci no existent
proAltaAppPreuPais(1,NULL,NULL,RSP); -- Alta del preu d'una aplicaci amb preu i codi de pais NULL
proAltaAppPreuPais(1,'28,30',NULL,RSP); -- Alta del preu d'una aplicaci amb codi de pais NULL
proAltaAppPreuPais(1,'28,30','ZZ',RSP); -- Alta del preu d'una aplicaci amb un codi de pais no existent
proAltaAppPreuPais(1,'28,30','ES',RSP); -- Alta del preu d'una aplicaci correcta

proEliminaAppPreuPais(NULL,NULL,RSP); -- Baixa del preu d'una aplicaci amb codi d'aplicaci NULL
proEliminaAppPreuPais(55,NULL,RSP); -- Baixa del preu d'una aplicaci amb codi d'aplicaci no existent
proEliminaAppPreuPais(1,NULL,RSP); -- Baixa del preu d'una aplicaci amb codi de pais NULL
proEliminaAppPreuPais(1,'ZZ',RSP); -- Baixa del preu d'una aplicaci amb codi de pais no existent
proEliminaAppPreuPais(1,'ES',RSP); -- Baixa del preu d'una aplicaci correcta

proConsultaAppPreuPais(NULL,NULL,intPreu,RSP); -- Consulta del preu d'una aplicaci a un pais amb codi d'aplicaci NULL
proConsultaAppPreuPais(55,NULL,intPreu,RSP); -- Consulta del preu d'una aplicaci a un pais amb codi d'aplicaci no existent
proConsultaAppPreuPais(1,NULL,intPreu,RSP); -- Consulta del preu d'una aplicaci a un pais amb codi de pais NULL
proConsultaAppPreuPais(1,'ZZ',intPreu,RSP); -- Consulta del preu d'una aplicaci a un pais amb codi de pais no existent
proConsultaAppPreuPais(1,'AR',intPreu,RSP); -- Consulta del preu d'una aplicaci a un pais amb codi de pais pel qual no existeix preu
proConsultaAppPreuPais(1,'GB',intPreu,RSP); -- Consulta del preu d'una aplicaci a un pais correcta
dbms_output.put_line('intPreu:' || intPreu); 

proAltaAppDescIdioma(NULL,NULL,NULL,RSP); -- Alta de la descripci d'una aplicaci per a un idioma amb codi d'aplicaci NULL
proAltaAppDescIdioma(55,NULL,NULL,RSP); -- Alta de la descripci d'una aplicaci per a un idioma amb codi d'aplicaci no existent
proAltaAppDescIdioma(1,NULL,NULL,RSP); -- Alta de la descripci d'una aplicaci per a un idioma amb descripci i codi d'idioma NULL
proAltaAppDescIdioma(1,'Nova descripci',NULL,RSP); -- Alta de la descripci d'una aplicaci per a un idioma amb codi d'idioma NULL
proAltaAppDescIdioma(1,'Nova descripci',56,RSP); -- Alta de la descripci d'una aplicaci per a un idioma amb codi d'idioma inexistent
proAltaAppDescIdioma(1,'Nova descripci',2,RSP); -- Alta de la descripci d'una aplicaci per a un idioma correcta

proEliminaAppDescIdioma(NULL,NULL,RSP); -- Baixa de la descripci d'una aplicaci per a un idioma amb codi d'aplicaci NULL
proEliminaAppDescIdioma(55,NULL,RSP); -- Baixa de la descripci d'una aplicaci per a un idioma amb codi d'aplicaci no existent
proEliminaAppDescIdioma(1,NULL,RSP); -- Baixa de la descripci d'una aplicaci per a un idioma amb codi d'idioma NULL
proEliminaAppDescIdioma(1,26,RSP); -- Baixa de la descripci d'una aplicaci per a un idioma amb codi d'idioma inexistent
proEliminaAppDescIdioma(1,8,RSP); -- Baixa de la descripci d'una aplicaci per a un idioma que no ha estat definit
proEliminaAppDescIdioma(1,2,RSP); -- Baixa de la descripci d'una aplicaci per a un idioma correcta

proConsultaAppDescIdioma(NULL,NULL,strDescripcio,RSP); -- Consulta de la descripci d'una aplicaci per a un idioma amb codi d'aplicaci NULL
proConsultaAppDescIdioma(55,NULL,strDescripcio,RSP); -- Consulta de la descripci d'una aplicaci per a un idioma amb codi d'aplicaci inexistent
proConsultaAppDescIdioma(1,NULL,strDescripcio,RSP); -- Consulta de la descripci d'una aplicaci per a un idioma amb codi d'idioma NULL
proConsultaAppDescIdioma(1,22,strDescripcio,RSP); -- Consulta de la descripci d'una aplicaci per a un idioma amb codi d'idioma inexistent
proConsultaAppDescIdioma(1,8,strDescripcio,RSP); -- Consulta de la descripci d'una aplicaci per a un idioma que no ha estat definit
proConsultaAppDescIdioma(1,4,strDescripcio,RSP); -- Consulta de la descripci d'una aplicaci per a un idioma correcta
dbms_output.put_line('strDescripcio:' || strDescripcio); 

proAltaAppSO(NULL,NULL,RSP); -- Alta de sistema operatiu suportat per una aplicaci amb codi d'aplicaci NULL
proAltaAppSO(55,NULL,RSP); -- Alta de sistema operatiu suportat per una aplicaci amb codi d'aplicaci inexistent
proAltaAppSO(1,NULL,RSP); -- Alta de sistema operatiu suportat per una aplicaci amb codi de sistema operatiu NULL
proAltaAppSO(1,'pep',RSP); -- Alta de sistema operatiu suportat per una aplicaci amb codi de sistema operatiu no existent
proAltaAppSO(1,'ANDR160',RSP); -- Alta de sistema operatiu suportat per una aplicaci correcta

proEliminaAppSO(NULL,NULL,RSP); -- Baixa de sistema operatiu suportat per una aplicaci amb codi d'aplicaci NULL
proEliminaAppSO(55,NULL,RSP); -- Baixa de sistema operatiu suportat per una aplicaci amb codi d'aplicaci inexistent
proEliminaAppSO(1,NULL,RSP); -- Baixa de sistema operatiu suportat per una aplicaci amb codi de sistema operatiu
proEliminaAppSO(1,'ANDR150',RSP); -- Baixa de sistema operatiu suportat per una aplicaci no definit previament
proEliminaAppSO(1,'ANDR160',RSP); -- Baixa de sistema operatiu suportat per una aplicaci correcta

proConsultaAppSO (NULL,tblLlistatSO,RSP); -- Consulta dels sistemes operatius suportats per una aplicaci amb codi d'aplicaci NULL
proConsultaAppSO (55,tblLlistatSO,RSP); -- Consulta dels sistemes operatius suportats per una aplicaci amb codi d'aplicaci inexistent
proConsultaAppSO (1,tblLlistatSO,RSP); -- Consulta dels sistemes operatius suportats per una aplicaci correcta
IF NOT (tblLlistatSO IS NULL) THEN
  FOR i IN tblLlistatSO.FIRST .. tblLlistatSO.LAST LOOP
    dbms_output.put_line(tblLlistatSO(i));
  END LOOP;
END IF;

proAltaBinariApp(NULL,NULL,NULL,NULL,NULL,NULL,intCodiBinari,RSP); -- Alta de fitxer binari amb codi d'aplicaci NULL
proAltaBinariApp(55,NULL,NULL,NULL,NULL,NULL,intCodiBinari,RSP); -- Alta de fitxer binari amb codi d'aplicaci inexistent
proAltaBinariApp(1,NULL,NULL,NULL,NULL,NULL,intCodiBinari,RSP); -- Alta de fitxer binari amb codi de sistema operatiu NULL
proAltaBinariApp(1,'ANDR460',NULL,NULL,NULL,NULL,intCodiBinari,RSP); -- Alta de fitxer binari amb codi de sistema operatiu inexistent
proAltaBinariApp(1,'SYMB950',NULL,NULL,NULL,NULL,intCodiBinari,RSP); -- Alta de fitxer binari amb versio NULL
proAltaBinariApp(1,'SYMB950','v2.0',NULL,NULL,NULL,intCodiBinari,RSP); -- Alta de fitxer binari amb hipervincle NULL
proAltaBinariApp(1,'SYMB950','v2.0','hipervincle',NULL,NULL,intCodiBinari,RSP); -- Alta de fitxer binari amb mida NULL
proAltaBinariApp(1,'SYMB950','v3.0','hipervincle','45696',67,intCodiBinari,RSP);-- Alta de fitxer binari amb codi de resoluci inexistent
proAltaBinariApp(1,'ANDR410','v1.0','hipervincle','45696',1,intCodiBinari,RSP);-- Alta de fitxer binari ja existent segons aplicaci, versio i sistema operatiu
proAltaBinariApp(1,'SYMB950','v3.0','hipervincle','45696',4,intCodiBinari,RSP);-- Alta de fitxer binari correcta
dbms_output.put_line('intCodiBinari:' || intCodiBinari); 

proBaixaBinariApp(NULL,RSP); -- Baixa de fitxer binari amb codi NULL
proBaixaBinariApp(56,RSP); -- Baixa de fitxer binari amb codi inexistent
proBaixaBinariApp(37,RSP); -- Baixa de fitxer binari correcta
proBaixaBinariApp(37,RSP); -- Baixa de fitxer binari que ja estava donat de baixa

proModificaBinariApp(NULL,NULL,NULL,NULL,NULL,RSP); -- Modificaci de binari amb codi NULL
proModificaBinariApp(56,NULL,NULL,NULL,NULL,RSP); -- Modificaci de binari amb codi inexistent
proModificaBinariApp(37,NULL,NULL,NULL,NULL,RSP); -- Modificaci de binari amb tots els camps NULL
proModificaBinariApp(37,'nou hipervincle',NULL,NULL,NULL,RSP); --  Modificaci de binari correcta: hipervincle
proModificaBinariApp(37,'nou hipervincle',123456,NULL,NULL,RSP); -- Modificaci de binari correcta: mida
proModificaBinariApp(37,'nou hipervincle',123456,24,NULL,RSP); -- Modificaci de binari amb codi de resolucio inexistent
proModificaBinariApp(37,'nou hipervincle',123456,4,NULL,RSP); -- Modificaci de binari correcta: resolucio
proModificaBinariApp(37,'nou hipervincle',123456,4,'F',RSP); -- Modificaci de binari amb flag activa amb valor incorrecte
proModificaBinariApp(37,'nou hipervincle',123456,4,'N',RSP); -- Modificaci de binari correcta: flag activa

proConsultaBinariApp (NULL,typDadesBinari,RSP); -- Consulta d'un binari amb codi NULL
proConsultaBinariApp (58,typDadesBinari,RSP); -- Consulta d'un binari amb codi inexistent
proConsultaBinariApp (1,typDadesBinari,RSP); -- Consulta d'un binari correcta
dbms_output.put_line('codi:' || typDadesBinari.codi || ',' 
                  || 'aplicacio:' || typDadesBinari.aplicacio || ',' 
                  || 'so:' || typDadesBinari.so || ',' 
                  || 'versio:' || typDadesBinari.versio || ',' 
                  || 'dataPujada:' || typDadesBinari.dataPujada || ',' 
                  || 'dataBaixa:' || typDadesBinari.dataBaixa || ',' 
                  || 'hipervincle:' || typDadesBinari.hipervincle || ',' 
                  || 'mida:' || typDadesBinari.mida || ',' 
                  || 'resolucio:' || typDadesBinari.resolucio || ',' 
                  || 'activa:' || typDadesBinari.activa);                  

proLlistatBinarisApp (NULL,tblLlistatBinaris,RSP); -- Consulta dels binaris d'una aplicaci amb codi aplicacio NULL
proLlistatBinarisApp (28,tblLlistatBinaris,RSP); -- Consulta dels binaris d'una aplicaci amb codi aplicacio inexistent
proLlistatBinarisApp (1,tblLlistatBinaris,RSP); -- Consulta dels binaris d'una aplicaci correcta
IF NOT (tblLlistatBinaris IS NULL) THEN
  FOR i IN tblLlistatBinaris.FIRST .. tblLlistatBinaris.LAST LOOP
    dbms_output.put_line(tblLlistatBinaris(i).codi
      || ',' || tblLlistatBinaris(i).aplicacio
      || ',' || tblLlistatBinaris(i).so
      || ',' || tblLlistatBinaris(i).versio
      || ',' || tblLlistatBinaris(i).dataPujada
      || ',' || tblLlistatBinaris(i).dataBaixa
      || ',' || tblLlistatBinaris(i).hipervincle
      || ',' || tblLlistatBinaris(i).mida
      || ',' || tblLlistatBinaris(i).resolucio
      || ',' || tblLlistatBinaris(i).activa);
  END LOOP;
END IF;

proAltaDesenvolupador(NULL,NULL,NULL,NULL,NULL,NULL,intCodiDesenvolupador,RSP); -- Alta desenvolupador amb nom identificador NULL
proAltaDesenvolupador('Desenvolupador1',NULL,NULL,NULL,NULL,NULL,intCodiDesenvolupador,RSP); -- Alta desenvolupador ambnom identificador ja existeix
proAltaDesenvolupador('Desenvolupador666',NULL,NULL,NULL,NULL,NULL,intCodiDesenvolupador,RSP); -- Alta desenvolupador amb codi de pais NULL
proAltaDesenvolupador('Desenvolupador666',NULL,NULL,NULL,NULL,'ZZ',intCodiDesenvolupador,RSP); -- Alta desenvolupador amb codi de pais inexistent
proAltaDesenvolupador('Desenvolupador666','nom empresa2','representant legal','adrea','9393939387','ES',intCodiDesenvolupador,RSP); -- Alta desenvolupador correcta
dbms_output.put_line('intCodiDesenvolupador:' || intCodiDesenvolupador);

proBaixaDesenvolupador(NULL,NULL,RSP); -- Baixa de desenvolupador amb codi i nom NULL
proBaixaDesenvolupador(102,NULL,RSP); -- Baixa de desenvolupador amb codi inexistent
proBaixaDesenvolupador(NULL,'nom del desenvolupador no existent',RSP); -- Baixa de desenvolupador amb nom no existeix
proBaixaDesenvolupador(10,NULL,RSP); -- Baixa de desenvolupador per codi correcta
proBaixaDesenvolupador(NULL,'Desenvolupador666',RSP); -- Baixa de desenvolupador per nom, el desenvolupador ja estava donat de baixa

proModificaDesenvolupador(NULL,NULL,NULL,NULL,NULL,NULL,RSP); -- Modificaci de desenvolupador amb codi NULL
proModificaDesenvolupador(56,NULL,NULL,NULL,NULL,NULL,RSP); -- Modificaci de desenvolupador amb codi inexistent
proModificaDesenvolupador(10,NULL,NULL,NULL,NULL,NULL,RSP); -- Modificaci de desenvolupador amb tots els camps NULL
proModificaDesenvolupador(10,NULL,NULL,NULL,NULL,'ZZ',RSP); -- Modificaci de desenvolupador amb codi pais inexistent
proModificaDesenvolupador(10,'empresa modificada','representant legal modificat','adrea modificada','00000000','AD',RSP); -- Modificaci de desenvolupador correcta

proConsultaDesenvolupador (NULL,typDadesDesenvolupador,RSP); -- Consulta de desenvolupador amb codi NULL
proConsultaDesenvolupador (534,typDadesDesenvolupador,RSP); -- Consulta de desenvolupador amb codi inexistent
proConsultaDesenvolupador (10,typDadesDesenvolupador,RSP); -- Consulta de desenvolupador correcta
dbms_output.put_line('codi:' || typDadesDesenvolupador.codi || ',' 
                  || 'idDesenvolupador:' || typDadesDesenvolupador.idDesenvolupador || ',' 
                  || 'dataAlta:' || typDadesDesenvolupador.dataAlta || ',' 
                  || 'dataBaixa:' || typDadesDesenvolupador.dataBaixa || ',' 
                  || 'nomEmpresa:' || typDadesDesenvolupador.nomEmpresa || ',' 
                  || 'nomRepLegal:' || typDadesDesenvolupador.nomRepLegal || ',' 
                  || 'adrea:' || typDadesDesenvolupador.adrea || ',' 
                  || 'telefon:' || typDadesDesenvolupador.telefon || ',' 
                  || 'pais:' || typDadesDesenvolupador.pais);

proAltaDesenvolupadorBinari(NULL,NULL,RSP); -- Alta desenvolupador d'un binari amb codi de desenvolupador NULL
proAltaDesenvolupadorBinari(45,NULL,RSP); -- Alta desenvolupador d'un binari amb codi de desenvolupador inexistent
proAltaDesenvolupadorBinari(1,NULL,RSP); -- Alta desenvolupador d'un binari amb codi de binari NULL
proAltaDesenvolupadorBinari(1,102,RSP); -- Alta desenvolupador d'un binari amb codi de binari inexistent
proAltaDesenvolupadorBinari(1,1,RSP); -- Alta desenvolupador d'un binari en que aquesta vinculacio ja existeix
proAltaDesenvolupadorBinari(1,3,RSP); -- Alta desenvolupador d'un binari correcta

proBaixaDesenvolupadorBinari(NULL,NULL,RSP); -- Baixa desenvolupador d'un binari amb codi de desenvolupador NULL
proBaixaDesenvolupadorBinari(45,NULL,RSP); -- Baixa desenvolupador d'un binari amb codi de desenvolupador inexistent
proBaixaDesenvolupadorBinari(1,NULL,RSP); -- Baixa desenvolupador d'un binari amb codi de binari NULL
proBaixaDesenvolupadorBinari(1,102,RSP); -- Baixa desenvolupador d'un binari amb codi de binari inexistent
proBaixaDesenvolupadorBinari(1,4,RSP); -- Baixa desenvolupador d'un binari en que aquesta vinculacio no existeix
proBaixaDesenvolupadorBinari(1,3,RSP); -- Baixa desenvolupador d'un binari correcta

proConsultaBinarisDes (NULL,tblLlistatBinaris,RSP); -- Consulta dels binaris implementats per un desenvolupador amb codi NULL
proConsultaBinarisDes (28,tblLlistatBinaris,RSP); -- Consulta dels binaris implementats per un desenvolupador amb codi inexistent
proConsultaBinarisDes (1,tblLlistatBinaris,RSP); -- Consulta dels binaris implementats per undesenvolupador correcta
IF NOT (tblLlistatBinaris IS NULL) THEN
  FOR i IN tblLlistatBinaris.FIRST .. tblLlistatBinaris.LAST LOOP
    dbms_output.put_line(tblLlistatBinaris(i).codi
      || ',' || tblLlistatBinaris(i).aplicacio
      || ',' || tblLlistatBinaris(i).so
      || ',' || tblLlistatBinaris(i).versio
      || ',' || tblLlistatBinaris(i).dataPujada
      || ',' || tblLlistatBinaris(i).dataBaixa
      || ',' || tblLlistatBinaris(i).hipervincle
      || ',' || tblLlistatBinaris(i).mida
      || ',' || tblLlistatBinaris(i).resolucio
      || ',' || tblLlistatBinaris(i).activa);
  END LOOP;
END IF;

proConsultaDesBinari (NULL,tblDesenvolupadors,RSP); -- Consulta dels desenvolupadors d'un binari amb codi de binari NULL
proConsultaDesBinari (96,tblDesenvolupadors,RSP); -- Consulta dels desenvolupadors d'un binari amb codi de binari inexistent
proConsultaDesBinari (1,tblDesenvolupadors,RSP); -- Consulta dels desenvolupadors d'un binari correcta
IF NOT (tblDesenvolupadors IS NULL) THEN
  FOR i IN tblDesenvolupadors.FIRST .. tblDesenvolupadors.LAST LOOP
    dbms_output.put_line(tblDesenvolupadors(i).codi
      || ',' || tblDesenvolupadors(i).idDesenvolupador
      || ',' || tblDesenvolupadors(i).dataAlta
      || ',' || tblDesenvolupadors(i).dataBaixa
      || ',' || tblDesenvolupadors(i).nomEmpresa
      || ',' || tblDesenvolupadors(i).nomRepLegal
      || ',' || tblDesenvolupadors(i).adrea
      || ',' || tblDesenvolupadors(i).telefon
      || ',' || tblDesenvolupadors(i).pais);
  END LOOP;
END IF;

proConsultaDesAplicacio (NULL,tblDesenvolupadors,RSP); -- Consulta dels desenvolupadors d'una aplicacio amb codi aplicacio NULL
proConsultaDesAplicacio (99,tblDesenvolupadors,RSP); -- Consulta dels desenvolupadors d'una aplicacio amb codi aplicacio inexistent
proConsultaDesAplicacio (1,tblDesenvolupadors,RSP); -- Consulta dels desenvolupadors d'una aplicacio correcta
IF NOT (tblDesenvolupadors IS NULL) THEN
  FOR i IN tblDesenvolupadors.FIRST .. tblDesenvolupadors.LAST LOOP
    dbms_output.put_line(tblDesenvolupadors(i).codi
      || ',' || tblDesenvolupadors(i).idDesenvolupador
      || ',' || tblDesenvolupadors(i).dataAlta
      || ',' || tblDesenvolupadors(i).dataBaixa
      || ',' || tblDesenvolupadors(i).nomEmpresa
      || ',' || tblDesenvolupadors(i).nomRepLegal
      || ',' || tblDesenvolupadors(i).adrea
      || ',' || tblDesenvolupadors(i).telefon
      || ',' || tblDesenvolupadors(i).pais);
  END LOOP;
END IF;

proConsultaDispUsuari (NULL,tblDispositius,RSP); -- Consulta dels dipositius d'un usuari amb codi usuari NULL
proConsultaDispUsuari (99,tblDispositius,RSP); -- Consulta dels dipositius d'un usuari amb codi usuari inexistent
proConsultaDispUsuari (1,tblDispositius,RSP); -- Consulta dels dipositius d'un usuari correcta
IF NOT (tblDispositius IS NULL) THEN
  FOR i IN tblDispositius.FIRST .. tblDispositius.LAST LOOP
    dbms_output.put_line(tblDispositius(i).codi
      || ',' || tblDispositius(i).IMEI
      || ',' || tblDispositius(i).modelDisp
      || ',' || tblDispositius(i).resolucio
      || ',' || tblDispositius(i).so);
  END LOOP;
END IF;

proAltaUsuari(NULL,NULL,NULL,NULL,intCodiUsuari,RSP); -- Alta usuari amb numero de mobil NULL
proAltaUsuari('121212121',NULL,NULL,NULL,intCodiUsuari,RSP); -- Alta usuari amb numero de mobil que ja existeix
proAltaUsuari('666666666',NULL,NULL,NULL,intCodiUsuari,RSP); -- Alta usuari amb operador NULL
proAltaUsuari('666666666','ZZZZ',NULL,NULL,intCodiUsuari,RSP); -- Alta usuari amb operador inexistent
proAltaUsuari('666666666','ORAN',NULL,NULL,intCodiUsuari,RSP); -- Alta usuari amb codi de pais NULL
proAltaUsuari('666666666','ORAN',NULL,'ZZ',intCodiUsuari,RSP); -- Alta usuari amb codi de pais inexistent
proAltaUsuari('666666666','ORAN','email.deprova@gmail.com','ES',intCodiUsuari,RSP); -- Alta usuari correcta

proBaixaUsuari(NULL,NULL,RSP); -- Baixa usuari amb codi usuari i numero de mobil NULL
proBaixaUsuari(22,'5555',RSP); -- Baixa usuari amb codi usuari inexistent  
proBaixaUsuari(NULL,'5555',RSP); -- Baixa usuari amb numero de mobil inexistent   
proBaixaUsuari(7,'111111112',RSP); -- Baixa usuari per codi usuari correcta
proBaixaUsuari(7,'111111112',RSP); -- Baixa usuari ja donat de baixa previament

proModificaUsuari(NULL,NULL,NULL,NULL,RSP); -- Modificacio usuari amb codi usuari NULL
proModificaUsuari(233,NULL,NULL,NULL,RSP); -- Modificacio usuari amb codi usuari inexistent 
proModificaUsuari(7,NULL,NULL,NULL,RSP); -- Modificacio usuari amb tots els camps a NULL
proModificaUsuari(7,NULL,'prova@telefonica.net',NULL,RSP); -- Modificacio email usuari correcta
proModificaUsuari(7,'PEPE',NULL,NULL,RSP); -- Modificacio usuari amb codi operador inexistent
proModificaUsuari(7,'MOVI',NULL,NULL,RSP); -- Modificacio operador usuari correcta
proModificaUsuari(7,NULL,NULL,'ZZ',RSP); -- Modificacio usuari amb codi pais inexistent
proModificaUsuari(7,NULL,NULL,'AD',RSP); -- Modificacio codi pais usuari correcta
proModificaUsuari(7,'VODA','email2@ya.com','GE',RSP); -- Modificacio correcta  

proConsultaUsuari (NULL,typDadesUsuari,RSP); -- Consulta dades usuari amb codi usuari NULL
proConsultaUsuari (58,typDadesUsuari,RSP); -- Consulta dades usuari amb codi usuari inexistent
proConsultaUsuari (7,typDadesUsuari,RSP); -- Consulta dades usuari correcta
dbms_output.put_line('codi:' || typDadesUsuari.codi || ',' 
                  || 'dataAlta:' || typDadesUsuari.dataAlta || ',' 
                  || 'dataBaixa:' || typDadesUsuari.dataBaixa || ',' 
                  || 'mobil:' || typDadesUsuari.mobil || ',' 
                  || 'operador:' || typDadesUsuari.operador || ',' 
                  || 'email:' || typDadesUsuari.email || ',' 
                  || 'pais:' || typDadesUsuari.pais);

proAltaDispositiuUsuari(NULL,NULL,NULL,NULL,NULL,intCodiDispositiu,RSP); -- Alta d'un dispositiu a un usuari amb codi usuari NULL
proAltaDispositiuUsuari(28,NULL,NULL,NULL,NULL,intCodiDispositiu,RSP); -- Alta d'un dispositiu a un usuari amb codi usuari inexistent
proAltaDispositiuUsuari(6,'IMEIDispositiu2Usuari6',NULL,NULL,NULL,intCodiDispositiu,RSP); -- Alta d'un dispositiu a un usuari amb IMEI existent
proAltaDispositiuUsuari(6,NULL,NULL,NULL,NULL,intCodiDispositiu,RSP); -- Alta d'un dispositiu a un usuari amb model dispositiu NULL
proAltaDispositiuUsuari(6,NULL,'NOK444',NULL,'ANDRXXX',intCodiDispositiu,RSP); -- Alta d'un dispositiu a un usuari amb model dispositiu inexistent
proAltaDispositiuUsuari(6,NULL,'NOK001',22,'ANDRXXX',intCodiDispositiu,RSP); -- Alta d'un dispositiu a un usuari amb codi de resolucio inexistent
proAltaDispositiuUsuari(6,NULL,'NOK001',1,'ANDRXXX',intCodiDispositiu,RSP); -- Alta d'un dispositiu a un usuari amb codi de sistema operatiu inexistent
proAltaDispositiuUsuari(6,'12232346445','NOK001',8,'ANDR150',intCodiDispositiu,RSP); -- Alta d'un dispositiu a un usuari correcta

proModificaDispositiu(NULL,NULL,NULL,NULL,NULL,RSP); -- Modificaci dispositiu amb codi NULL
proModificaDispositiu(28,NULL,NULL,NULL,NULL,RSP); -- Modificaci dispositiu amb codi inexistent
proModificaDispositiu(13,NULL,NULL,NULL,NULL,RSP); -- Modificaci dispositiu amb tots els camps NULL
proModificaDispositiu(13,'12232346445',NULL,NULL,NULL,RSP); -- Modificaci dispositiu amb IMEI ja existent
proModificaDispositiu(13,'12232346478','NOK111',NULL,NULL,RSP); -- Modificaci dispositiu amb codi de model inexistent
proModificaDispositiu(13,'12232346478','NOK001',56,NULL,RSP); -- Modificaci dispositiu amb codi de resolucio inexistent
proModificaDispositiu(13,'12232346478','NOK001',4,'ANDR155',RSP); -- Modificaci dispositiu amb codi de sistema operatiu inexistent
proModificaDispositiu(13,'12232346478','NOK001',4,'ANDR150',RSP); -- Modificaci dispositiu correcta
proModificaDispositiu(13,'12232346479',NULL,NULL,NULL,RSP); -- Modificaci dispositiu correcta
proModificaDispositiu(13,NULL,'SAM002',NULL,NULL,RSP); -- Modificaci dispositiu correcta
proModificaDispositiu(13,NULL,NULL,5,NULL,RSP); -- Modificaci dispositiu correcta
proModificaDispositiu(13,NULL,NULL,NULL,'ANDR410',RSP); -- Modificaci dispositiu correcta

proLlistatDesPais(NULL,tblLlistatDesPais,RSP); -- Llistat de tots els desenvolupadors d'un pais, codi de pais NULL
proLlistatDesPais('ZZ',tblLlistatDesPais,RSP); -- Llistat de tots els desenvolupadors d'un pais, codi de pais inexistent
proLlistatDesPais('GB',tblLlistatDesPais,RSP); -- Llistat de tots els desenvolupadors d'un pais correcte
IF NOT (tblLlistatDesPais IS NULL) THEN
  FOR i IN tblLlistatDesPais.FIRST .. tblLlistatDesPais.LAST LOOP
    dbms_output.put_line(tblLlistatDesPais(i).codi
      || ',' || tblLlistatDesPais(i).idDesenvolupador
      || ',' || tblLlistatDesPais(i).dataAlta
      || ',' || tblLlistatDesPais(i).dataBaixa
      || ',' || tblLlistatDesPais(i).nomEmpresa
      || ',' || tblLlistatDesPais(i).nomRepLegal
      || ',' || tblLlistatDesPais(i).adrea
      || ',' || tblLlistatDesPais(i).telefon
      || ',' || tblLlistatDesPais(i).appPublicades);
  END LOOP;
END IF;

proModificaAplicacio(1,NULL,NULL,NULL,'S',RSP); -- Modificaci del flag d'aplicaci activa a 'S'   
proModificaAplicacio(4,NULL,NULL,NULL,'S',RSP); -- Modificaci del flag d'aplicaci activa a 'S'   
proLlistatAppActives (tblLlistatAppActives,RSP); -- Llistat de totes les aplicacions actives
IF NOT (tblLlistatAppActives IS NULL) THEN
  FOR i IN tblLlistatAppActives.FIRST .. tblLlistatAppActives.LAST LOOP
    dbms_output.put_line(tblLlistatAppActives(i).codi
      || ',' || tblLlistatAppActives(i).idAplicacio
      || ',' || tblLlistatAppActives(i).dataPujada
      || ',' || tblLlistatAppActives(i).dataBaixa
      || ',' || tblLlistatAppActives(i).versio
      || ',' || tblLlistatAppActives(i).linkVideo
      || ',' || tblLlistatAppActives(i).resolucioMinima
      || ',' || tblLlistatAppActives(i).descarregues);
  END LOOP;
END IF;

proDescarrega(NULL,NULL,NULL,RSP); -- Descarrega amb codi dispositiu NULL
proDescarrega(1,NULL,NULL,RSP); -- Descarrega amb codi de binari NULL
proDescarrega(1,1,NULL,RSP); -- Descarrega amb codi de pagament NULL
proDescarrega(350,1,1,RSP); -- Descarrega amb codi dispositiu inexistent
proDescarrega(1,350,1,RSP); -- Descarrega amb codi de binari inexistent
proDescarrega(1,1,350,RSP); -- Descarrega amb codi de pagament inexistent
proDescarrega(1,1,2,RSP); -- Descarrega correcta
proDescarrega(1,2,2,RSP); -- Descarrega correcta
proDescarrega(1,3,2,RSP); -- Descarrega correcta
proDescarrega(2,4,2,RSP); -- Descarrega correcta
proDescarrega(2,5,2,RSP); -- Descarrega correcta
proDescarrega(2,6,2,RSP); -- Descarrega correcta

proLlistatAppAny (NULL,NULL,'2012',tblLlistatAppAny,RSP); -- Llistat de tots els paisos on s'ha descarregat una aplicacio determinada i en un any en concret, codi aplicacio i descripcio NULL
proLlistatAppAny (566,NULL,'2012',tblLlistatAppAny,RSP); -- Llistat de tots els paisos on s'ha descarregat una aplicacio determinada i en un any en concret, codi aplicacio no existeix
proLlistatAppAny (NULL,'Aplicacio12','2012',tblLlistatAppAny,RSP); -- Llistat de tots els paisos on s'ha descarregat una aplicacio determinada i en un any en concret, descripcio aplicacio no existeix
proLlistatAppAny (1,NULL,NULL,tblLlistatAppAny,RSP); -- Llistat de tots els paisos on s'ha descarregat una aplicacio determinada i en un any en concret, any NULL
proLlistatAppAny (1,NULL,'PEPA',tblLlistatAppAny,RSP); -- Llistat de tots els paisos on s'ha descarregat una aplicacio determinada i en un any en concret, any amb valor incorrecte
proLlistatAppAny (1,NULL,'2012',tblLlistatAppAny,RSP); -- Llistat de tots els paisos on s'ha descarregat una aplicacio determinada i en un any en concret, correcte
IF NOT (tblLlistatAppAny IS NULL) THEN
  FOR i IN tblLlistatAppAny.FIRST .. tblLlistatAppAny.LAST LOOP
    dbms_output.put_line(tblLlistatAppAny(i).pais
      || ',' || tblLlistatAppAny(i).descarregues);
  END LOOP;
END IF;

proLlistatDescUsuari (NULL,tblLlistatDescUsuari,RSP); -- Llistat de totes les descarregues realitzades per un usuari, numero de mobil NULL
proLlistatDescUsuari ('12',tblLlistatDescUsuari,RSP); -- Llistat de totes les descarregues realitzades per un usuari, numero de mobil inexistent
proLlistatDescUsuari ('121212121',tblLlistatDescUsuari,RSP); -- Llistat de totes les descarregues realitzades per un usuari, correcte
IF NOT (tblLlistatDescUsuari IS NULL) THEN
  FOR i IN tblLlistatDescUsuari.FIRST .. tblLlistatDescUsuari.LAST LOOP
    dbms_output.put_line(tblLlistatDescUsuari(i).dispositiuIMEI
      || ',' || tblLlistatDescUsuari(i).dispositiuModel
      || ',' || tblLlistatDescUsuari(i).aplicacio
      || ',' || tblLlistatDescUsuari(i).dataHora
      || ',' || tblLlistatDescUsuari(i).modePagament
      || ',' || tblLlistatDescUsuari(i).operador
      || ',' || tblLlistatDescUsuari(i).preu
      || ',' || tblLlistatDescUsuari(i).pais);
  END LOOP;
END IF;

proLlistatTop20Usuari (NULL,tblLlistatTop20Usuari,RSP); -- Llistat, per una any donat, dels 20 usuaris que ms han gastat, any NULL
proLlistatTop20Usuari ('PEPA',tblLlistatTop20Usuari,RSP); -- Llistat, per una any donat, dels 20 usuaris que ms han gastat, any incorrecte
proLlistatTop20Usuari ('2012',tblLlistatTop20Usuari,RSP); -- Llistat, per una any donat, dels 20 usuaris que ms han gastat, correcte
IF NOT (tblLlistatTop20Usuari IS NULL) THEN
  FOR i IN tblLlistatTop20Usuari.FIRST .. tblLlistatTop20Usuari.LAST LOOP
    dbms_output.put_line(tblLlistatTop20Usuari(i).codi
      || ',' || tblLlistatTop20Usuari(i).dataAlta
      || ',' || tblLlistatTop20Usuari(i).dataBaixa
      || ',' || tblLlistatTop20Usuari(i).mobil
      || ',' || tblLlistatTop20Usuari(i).operador
      || ',' || tblLlistatTop20Usuari(i).email
      || ',' || tblLlistatTop20Usuari(i).pais
      || ',' || tblLlistatTop20Usuari(i).despesa);
  END LOOP;
END IF;

END;

