-------------------------------------------------
-- CREACIO DE LES TAULES DEL MODUL ESTADISTIC  --
-------------------------------------------------

------------------------------------
-- Taula d'Estadstiques Generals --
------------------------------------
CREATE TABLE ESTADISTIQUESGENERALS (
   DESCARREGUES NUMBER, 
	 EUROSDESCARREGUES NUMBER (10,2)
);
-- Inserim el registre inicial i nic, desprs noms hi poden haver actualitzacions
INSERT INTO ESTADISTIQUESGENERALS VALUES (0,0);

----------------------------------
-- Taula d'Estadistiques Anuals --
----------------------------------
CREATE TABLE ESTADISTIQUESANUALS (
   ANYESTADISTICA CHAR(4 CHAR) CONSTRAINT PK_ESTADISTIQUESANUALS PRIMARY KEY, 
	 MITJANADESCARREGUES NUMBER (6,2) DEFAULT 0,
   DESCARREGUES NUMBER DEFAULT 0,
   USUARIS NUMBER DEFAULT 0,
   DESENVOLUPADORMAXDESC VARCHAR2 (500 CHAR),
   DESENVOLUPADORMAXDESCNUMERO NUMBER DEFAULT 0,
   APLICACIOMAXRECAPTACIO VARCHAR2 (500 CHAR),
   APLICACIOMAXRECAPTACIODES VARCHAR2 (500 CHAR)
);

-----------------------------------------------------
-- Taula d'Estadistiques Anuals de Desenvolupadors --
-----------------------------------------------------
CREATE TABLE ESTADISTIQUESANUALSDES (
    ANYESTADISTICA CHAR(4 CHAR), 
    DESENVOLUPADOR VARCHAR2(50 CHAR),
    DESCARREGUES NUMBER DEFAULT 0,
    CONSTRAINT PK_ESTADISTIQUESANUALSDES PRIMARY KEY (ANYESTADISTICA,DESENVOLUPADOR)
);

------------------------------------------------
-- Taula d'Estadistiques Anuals d'Aplicacions --
------------------------------------------------
CREATE TABLE ESTADISTIQUESANUALSAPP (
    ANYESTADISTICA CHAR(4 CHAR) CONSTRAINT NN_ESTADISTIQUESANUALSAPP_ANY NOT NULL, 
    APLICACIO VARCHAR2(50 CHAR) CONSTRAINT NN_ESTADISTIQUESANUALSAPP_APP NOT NULL,
    DESENVOLUPADORS VARCHAR2(500 CHAR) CONSTRAINT NN_ESTADISTIQUESANUALSAPP_DES NOT NULL,
    EUROSDESCARREGUES NUMBER(7,2) DEFAULT 0,
    CONSTRAINT PK_ESTADISTIQUESANUALSAPP PRIMARY KEY (ANYESTADISTICA,APLICACIO)
);

-------------------------------------------
-- Taula d'Estadistiques Anuals per Pais --
-------------------------------------------
CREATE TABLE ESTADISTIQUESANUALSPAIS (
    ANYESTADISTICA CHAR(4 CHAR) CONSTRAINT NN_ESTANUALSPAIS_ANY NOT NULL, 
    PAIS CHAR(2 CHAR) CONSTRAINT FK1_ESTANUALSPAIS_PAIS REFERENCES PAIS(CODI),
    USUARISDIF NUMBER DEFAULT 0,
    INGRESSOSUSUARIS NUMBER DEFAULT 0,
    APLICACIONSDIF NUMBER DEFAULT 0,
    CONSTRAINT PK_ESTADISTIQUESANUALSPAIS PRIMARY KEY (ANYESTADISTICA,PAIS)
);
